//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializelistArticlesRequest")
inline fun listArticlesRequest(block: gg.dsepractice.chinese.v1alpha1.ListArticlesRequestKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ListArticlesRequest =
  gg.dsepractice.chinese.v1alpha1.ListArticlesRequestKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.ListArticlesRequest.newBuilder()).apply { block() }._build()
object ListArticlesRequestKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.ListArticlesRequest.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.ListArticlesRequest.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.ListArticlesRequest = _builder.build()

    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationOption pagination_option = 1 [json_name = "paginationOption"];</code>
     */
    var paginationOption: gg.dsepractice.chinese.v1alpha1.PaginationOption
      @JvmName("getPaginationOption")
      get() = _builder.getPaginationOption()
      @JvmName("setPaginationOption")
      set(value) {
        _builder.setPaginationOption(value)
      }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationOption pagination_option = 1 [json_name = "paginationOption"];</code>
     */
    fun clearPaginationOption() {
      _builder.clearPaginationOption()
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationOption pagination_option = 1 [json_name = "paginationOption"];</code>
     * @return Whether the paginationOption field is set.
     */
    fun hasPaginationOption(): kotlin.Boolean {
      return _builder.hasPaginationOption()
    }

    /**
     * <code>bool show_own_unlisted = 2 [json_name = "showOwnUnlisted"];</code>
     */
    var showOwnUnlisted: kotlin.Boolean
      @JvmName("getShowOwnUnlisted")
      get() = _builder.getShowOwnUnlisted()
      @JvmName("setShowOwnUnlisted")
      set(value) {
        _builder.setShowOwnUnlisted(value)
      }
    /**
     * <code>bool show_own_unlisted = 2 [json_name = "showOwnUnlisted"];</code>
     */
    fun clearShowOwnUnlisted() {
      _builder.clearShowOwnUnlisted()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.ListArticlesRequest.copy(block: gg.dsepractice.chinese.v1alpha1.ListArticlesRequestKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ListArticlesRequest =
  gg.dsepractice.chinese.v1alpha1.ListArticlesRequestKt.Dsl._create(this.toBuilder()).apply { block() }._build()

val gg.dsepractice.chinese.v1alpha1.ListArticlesRequestOrBuilder.paginationOptionOrNull: gg.dsepractice.chinese.v1alpha1.PaginationOption?
  get() = if (hasPaginationOption()) getPaginationOption() else null

